// by Ty Rayner

out vec4			fragColor;
in vec2				texcoord;
in vec3				normal;

uniform sampler2D	flagTex;

uniform float		flagAlpha;

void main(void)
{
	vec2 tc = texcoord;
	
	vec4 tcPost, tcFlag;
	float postAlpha;
	float postVal;
	vec3 n;
	
	n = normal;
	
	postAlpha = 1. - step(.05, (1.-tc.y));
	postVal = (1.-tc.y) / .05;
	postVal = (2 * postVal) - 1;
	postVal = 1. - (postVal * postVal);
	postVal = clamp(postVal, 0, 1);
	
	tcPost = vec4(postVal,postVal,postVal,1);
	
	tcFlag = texture(
					 flagTex,
					 vec2(
						  (1.-tc.y),
						  (tc.x * 1.5) - 0.5
						  )
					 );
	
	
	
	vec4 tcFinal = mix(tcFlag,tcPost,postAlpha);
	
	vec4 texColor = tcFinal;
	texColor.a *= flagAlpha;
	
	fragColor = texColor;
	//fragColor = vec4(1,0,0,1);
}
