#!/bin/sh

echo ''
echo 'NetShade Uninstaller 1.3 (c)2014 www.raynersw.com'
echo ''

sudo whoami >/dev/null 2>/dev/null

if [ $? != 0 ]; then
	echo 'Failed to setuid to root';
	exit;
fi

echo Starting NetShade uninstall for uid $1
echo 'Terminating NetShade'; killall NetShade >/dev/null 2>/dev/null;
echo 'Terminating openvpn'; killall openvpn >/dev/null 2>/dev/null;
echo 'Terminating netshade-ctl-2'; killall com.raynersw.netshade-ctl-2 >/dev/null 2>/dev/null;
echo 'Terminating nshctldo'; killall com.raynersw.nshctldo >/dev/null 2>/dev/null;
echo 'Terminating nshfixer'; killall com.raynersw.nshfixer >/dev/null 2>/dev/null;
echo 'Unloading helper’s launchctl plist'; launchctl unload /Library/LaunchDaemons/com.raynersw.netshade-ctl-2.plist
echo 'Deleting helper’s launchctl plist'; rm -f /Library/LaunchDaemons/com.raynersw.netshade-ctl-2.plist
echo 'Unloading tun'; kextunload '/Library/Extensions/tun.kext' >/dev/null 2>/dev/null;
echo 'Unloading tap'; kextunload '/Library/Extensions/tap.kext' >/dev/null 2>/dev/null;
echo 'Deleting NetShade application support directory'; rm -Rf ${HOME}/Library/Application\ Support/com.raynersw.NetShade >/dev/null 2>/dev/null;
echo 'Purging NetShade preferences'; sudo -u\#$1 defaults delete com.raynersw.NetShade >/dev/null 2>/dev/null;
echo 'Deleting NetShade preferences file'; rm -f ${HOME}/Library/Preferences/com.raynersw.NetShade.plist >/dev/null 2>/dev/null;
echo 'Deleting helper tool netshade-ctl-2'; rm -f '/Library/PrivilegedHelperTools/com.raynersw.netshade-ctl-2' >/dev/null 2>/dev/null;
echo 'Deleting legacy helper tool nshctldo'; rm -f '/Library/PrivilegedHelperTools/com.raynersw.nshctldo' >/dev/null 2>/dev/null;
echo 'Deleting legacy helper tool nshfixer'; rm -f '/Library/PrivilegedHelperTools/com.raynersw.nshfixer' >/dev/null 2>/dev/null;
echo 'Deleting tun'; rm -Rf '/Library/Extensions/tun.kext' >/dev/null 2>/dev/null;
echo 'Deleting tap'; rm -Rf '/Library/Extensions/tap.kext' >/dev/null 2>/dev/null;
echo 'Deleting legacy-legacy components proxycontrol and nshctl'; rm -f '/usr/libexec/proxycontrol'; rm -f '/usr/libexec/nshctl';

echo 'Un-setting proxies in System Preferences';
IFS="
";
for i in `networksetup -listallnetworkservices`; do
	if [ "$i" = "An asterisk (*) denotes that a network service is disabled." ] ; then
		continue;
	fi
	printf "networksetup -setwebproxystate \"%s\" off\n" $i | /bin/sh;
	printf "networksetup -setsecurewebproxystate \"%s\" off\n" $i | /bin/sh;
done


echo 'Removing security authorizations for helper tool';
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.getUID"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.bundlePath"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.setBundlePath"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.getVersion"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.checkAuthorization"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.selfTest"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.killAllOpenVPN"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.listSets"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.listInterfacesInSet"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.currentSet"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.configurations"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.deleteConfigurations"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.setConfiguration"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.tunTapIsInstalled"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.installTunTap"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.removeTunTap"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.tunTapIsLoaded"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.loadTunTap"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.unloadTunTap"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.runScript"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.checkGoogleDNS"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.installGoogleDNS"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.removeGoogleDNS"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.raiseException"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.connectOpenVPNAuthorization"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.disconnectOpenVPNAuthorization"
security -q authorizationdb remove "com.raynersw.netshade-ctl-2.openVPNVersionWithReply"




echo ''

echo 'Verifying...'

if (
[ -f ${HOME}/Library/Application\ Support/com.raynersw.NetShade ] ||
[ -f '/Library/PrivilegedHelperTools/com.raynersw.netshade-ctl-2' ] ||
[ -f '/Library/PrivilegedHelperTools/com.raynersw.nshctldo' ] ||
[ -f '/Library/PrivilegedHelperTools/com.raynersw.nshfixer' ] ||
[ -f '/Library/Extensions/tun.kext' ] ||
[ -f '/Library/Extensions/tap.kext' ]
) ; then
	echo 'Error: Some files could not be uninstalled.';


	if ([ -f '${HOME}/Library/Application\ Support/com.raynersw.NetShade' ]) ; then
		echo 'Could not remove ${HOME}/Library/Application\ Support/com.raynersw.NetShade';
	fi


	if ([ -f '/Library/PrivilegedHelperTools/com.raynersw.netshade-ctl-2' ]) ; then
		echo 'Could not remove /Library/PrivilegedHelperTools/com.raynersw.netshade-ctl-2';
	fi


	if ([ -f '/Library/PrivilegedHelperTools/com.raynersw.nshctldo' ]) ; then
		echo 'Could not remove /Library/PrivilegedHelperTools/com.raynersw.nshctldo';
	fi


	if ([ -f '/Library/PrivilegedHelperTools/com.raynersw.nshfixer' ]) ; then
		echo 'Could not remove /Library/PrivilegedHelperTools/com.raynersw.nshfixer';
	fi


	if ([ -f '/Library/Extensions/tun.kext' ]); then
		echo 'Could not remove /Library/Extensions/tun.kext';
	fi


	if ([ -f '/Library/Extensions/tap.kext' ]); then
		echo 'Could not remove /Library/Extensions/tap.kext';
	fi

	echo '';
else
	echo 'NetShade successfully uninstalled.';
	echo '';
	echo 'NOTE: This uninstaller has deleted all of the NetShade support files and programs, but not the NetShade app itself. Please manually delete NetShade.app to finalize uninstallation, if desired.';
	echo '';
fi


