// by Ty Rayner

in vec2				texcoord;
in vec3				normal;
out vec4			fragColor;
uniform float		rotation;

void main(void)
{
	vec2 tcnorm = vec2(texcoord.x * 2. - 1, texcoord.y * 2. - 1);
	
	float rads = atan(tcnorm.y, tcnorm.x);
	float hypot = sqrt(tcnorm.x*tcnorm.x + tcnorm.y*tcnorm.y);
	float mask0 = smoothstep(.68, .74, hypot);
	float mask1 = smoothstep(.93, .99, hypot);
	float mask = mask0 - mask1;
	vec3 n;
	
	n = normal;
	rads += 3.1415;
	
	rads += rotation;
	
	rads = mod(rads, 6.283);
	
	float c = smoothstep(6.283, 0, rads);
	
	fragColor = vec4(c * mask, c * mask, c * mask, c * mask);
}

